//
//  FieldScene.h
//  Awars III
//
//  Created by Killery on 2013/02/22.
//  Copyright (c) 2013年 Killery. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <AVFoundation/AVFoundation.h>
#import <AVKit/AVKit.h>
#import <stdio.h>
#import "MapEditor.h"
#import "MapView.h"
#import "FieldView.h"
#import "MapChipList.h"
#import "UnitChipList.h"
#import "BuildChipList.h"
#import "EventScene.h"
#import "BattleView.h"
#import "SaveDataList.h"
#import "LevelList.h"
#import "LoadChipList.h"
#import "ScenarioEditor.h"

#define SAVEDATADATMAX 4096
#define DATAFILE_NAME "data.dat"
#define INSTANT_IMG "image.png"
#define OPTIONFILE_NAME "opData.dat"
#define STANDFILE_NAME "stand.dat"

#define FIELD_TYPE_A 0
#define FIELD_TYPE_B 1
#define FIELD_TYPE_C 2
#define FIELD_TYPE_D 3
#define FIELD_TYPE_E 4
#define FIELD_TYPE_S 5
#define FIELD_TYPE_SS 6

#define MOVE_TYPE_RIKU 0
#define MOVE_TYPE_UMI 1
#define MOVE_TYPE_CHU 2
#define MOVE_TYPE_SORA 3

typedef struct _STATUS2{
    
    double HP;
    double EN;
    double WT;
    
    int MOV;
    double ARM;
    double MOB;
    double LIM;
    
    short size;//T:極小 S:人型サイズ B:乗り物サイズ H:建物サイズ G:巨人サイズ M:モビールスーツサイズ L：戦艦サイズ LL：大戦艦サイズ E：移動基地サイズ I：大陸サイズ
    short typeMOVE;
    short loadCnt;
    
    int cSupply;
    int cFood;
    int cMoney;
    int cWT;
    
}STATUS2;

typedef struct _LOADCHIPD{
    int chipNumb;
    
    NSString *name;
    NSString *nameID;
    struct _RESIST R_C;
    struct _STATUS2 S_C;

}LOADCHIPD;

typedef struct _LOADCHIP{
    
    struct _RESIST R_C;
    struct _RESIST R_M;
    struct _ATTACK *A;
    
    NSString *name;
    NSString *nameRecognition;
    NSString *nameID;
    
    struct _STATUS2 S_C;
    struct _STATUS2 S_M;
    
    NSString *iName;
    NSImage *img;
    
    NSString *iNameb;
    NSImage *imgb;
    
    int chipNumb;
    
    NSString *aName;
    int attackListNum;
    
}LOADCHIP;

typedef struct _BSTATUS{
    int HP;
    int WT;
    int WTE;
    int WTN;
    NSString *name;
    
}BSTATUS;

typedef struct _BUILDCHIPD{
    int chipNumb;
    
    NSString *name;
    NSString *nameID;
    struct _BSTATUS S_C;
    
}BUILDCHIPD;

typedef struct _BUILDCHIP{
    
    NSString *name;
    NSString *nameR;
    NSString *nameID;
    
    struct _RESEARCH *R;
    struct _BSTATUS S_C;
    struct _BSTATUS S_M;
    
    int chipNumb;
    
    int dmgfix;
    int type;
    int defLv;
    
    int Csupply;
    int Cfood;
    int Cmoney;
    
    
    int CsupplyNext;
    int CfoodNext;
    int CmoneyNext;
    
    int Esupply;
    int Efood;
    int Emoney;
    
    
    int recHP;
    int recMP;
    int recEN;
    int recHPL;
    bool inroadsFlag;
    bool capture;
    NSString *linkDest;
    NSString *linkNext;
    
    
    NSString *iName;
    NSImage *img;
    
    NSString *iNameb;
    NSImage *imgb;
    
    bool invisible;
    bool GuildFlag;
    
}BUILDCHIP;

typedef struct _UNIT{
    struct _UNIT *next;
    struct _UNITCHIP C;
    struct _LOADCHIP CL;
    bool CPU;
    int number;
    int team;
    int chipNumber;
    int chipNumberL;
    
    int x;
    int y;
    int z;
    
    int ix;
    int iy;
    int iz;
    
    NSImage *img;
    
    bool loadChipFlag;
    
    bool dead;
    NSString *army;
    bool unControlable;
    bool joinArmyFromNext;
    bool persuasion;
    
    bool targType1L;
    bool targType2L;
    bool targType1D;
    bool targType2D;
    
    int atkRange;
    
}UNIT;

typedef struct _UNITD{
    bool CPU;
    int number;
    int team;
    int chipNumber;
    int chipNumberL;
    
    int x;
    int y;
    int z;
    
    int ix;
    int iy;
    int iz;
    
    bool dead;
    
    bool loadChipFlag;
    
    bool unControlable;
    bool joinArmyFromNext;
    bool persuasion;
    
    bool targType1L;
    bool targType2L;
    bool targType1D;
    bool targType2D;

    NSString *army;
    
    int imgAdCnt;
    int imgAdFix;
    NSImage *img;

    struct _UNITCHIPD C;
    struct _LOADCHIPD CL;
}UNITD;

typedef struct _UNION{
    
    
    
}UNION;

typedef struct _BUILD{
    struct _BUILD *next;
    struct _BUILDCHIP C;
    int number;
    int team;
    int chipNumber;
    int makeLv;
    
    int x;
    int y;
    int z;
    
    NSImage *img;
    
    bool dead;
    

}BUILD;

typedef struct _BUILDD{
    
    int number;
    int team;
    int chipNumber;
    int makeLv;
    
    int x;
    int y;
    int z;
    
    bool dead;
    
    int imgAdCnt;
    int imgAdFix;
    NSImage *img;

    struct _BUILDCHIPD C;
    
}BUILDD;

typedef struct _PLAYER{
    
    NSString *name;
    int type;
    
    int resource;
    int food;
    int money;
    
    int base;
    int unit;
    
    UNIT *U;

}PLAYER;

typedef struct _UNITPOINT{

    struct _UNITPOINT *next;
    
    int x;
    int y;

}UNITPOINT;

NSMutableArray *SAV;

LOADCHIP LC[4096];
BUILDCHIP BC[512];

double eventTime;

PLAYER P[10];

UNIT *U;
UNIT *U2;
int AUN[255];
int DUN[255];
int messageProcess;

int targType1cnt[2];
int targType2cnt[2];
bool targType2Lflag;
bool targType2Dflag;

int placeVL[64];
int placeVD[64];

BUILD *B;
BUILD *BTop;

NSPoint menuPoint;
bool menuDisplayFlag;
bool initStatusFlag;

bool bLoopFlag;
int crCAL;
int crCAL1;
int crCAL2;
bool dcRdy;
bool dcRdy2;

int crCRL;

int crBCL;
bool bclRdy;

int crCSL;
bool cslRdy;
UNITCHIP CSLUC;
UNIT *CSLU;
UNIT *CSLUorigin;


bool battleSetUp;
bool battleSetUpIgnore;
bool battleRdy;
bool pushStanbyFlag;

UNITCHIP *BRU;
int BRUindex;

bool wtRdy;
bool wtRdy2;
bool wtRdy3;
bool wtRdyB;
int wtPx, wtPy, wtUnitNum;
UNIT *unitBreak;
bool wtMovedFlag;
bool wtAttackedFlag;

bool battleBegin;

int TeamCount0;
int TeamCount2;
bool TeamCountFlag;

bool endGameCondition;
bool blueWinFlag;
bool redWinFlag;

bool battleDef1Flag;
bool battleDef2Flag;
bool battleDod1Flag;
bool battleDod2Flag;
bool battleSetFlag;
bool battleSet1Flag;
bool battleSet2Flag;
bool battleSet2PushedFlag;
bool battleSettingFlag;

bool cIncludeCreateFlag;
bool cIncludeSummonFlag;

bool initMapEventFlag;
bool messageDialog;
int msgLvl;
int msgCnt;
int msgMax;
int msgLvlMax;
bool initImgFlag;
int MSDnum;
bool initStringNum;
bool messageSwitchFlag1;
bool bugFixFlag1;
bool bugFixFlag2;
bool bugFixFlag3;

struct _MAPSCRIPTD *MSDTO;

bool messageEndFlag;

bool SwitchONflag;
bool SwitchOFFflag;

int mostNumSub;
bool cpuAImodeflag;

UNIT *UTop;

bool retardhelp1;
bool retardhelp2;
bool battleReadyUpFlag;

bool avPlayerFlag1;
bool avPlayerFlag2;
bool animationFlag1;
bool animationFlag2;
bool animationFlag3;
int aniFrameCnt;

ATTACK *attackCR;
ATTACK *attackCR2;
ATTACK *attackTop;
ATTACK *attackTop2;
UNIT *effCun;

bool fuckingLoadBugFix;
bool assholeLoadBugFix;
bool battleEndFlag;

int oopsCnt;
int lmao;
int vaginaCnt;

typedef struct _BGMUSIC{
    
    NSString *name;
    NSString *fName;
    NSSound *snd;
    
}BGMUSIC;

typedef struct _SEFFECT{
    
    NSString *name;
    NSString *fName;
    NSSound *snd;
    
}SEFFECT;

typedef struct _GAMEOVER{
    
    NSString *fNname;
    NSImage *img;
    bool gaovFlag;
    bool edcdFlag;
    
}GAMEOVER;

typedef struct _STAGECLEAR{
    
    bool scFlag;
    bool edcdFlag;
    
}STAGECLEAR;



typedef struct _EVENTIMAGE{
    
    struct _EVENTIMAGE *next;
    
    NSString *name;
    
    NSImage *img;
    
}EVENTIMAGE;

EVENTIMAGE *EIMG;
EVENTIMAGE *EIMGtop;

struct _MAPSCRIPT0;

typedef struct _ENDGAMECONDITION{
    
    int endType1;
    int endType2;
    
    NSString *etValue1[64];
    NSString *etValue2[64];
    
}ENDGAMECONDITION;
typedef struct _MAPSCRIPT1{
    //文章スクリプト
    NSString *name;
    NSString *str;
    NSImage *img;
    NSString *iName;
    NSString *nameID;
    
}MAPSCRIPT1;

typedef struct _MAPSCRIPT2A{
    
    struct _MAPSCRIPT2A *next;
    
    struct _MAPSCRIPT0 *P;
    
}MAPSCRIPT2A;

typedef struct _MAPSCRIPT2{
    //文章選択肢スクリプト
    
    struct _MAPSCRIPT2 *next;
    
    NSString *selection;
    NSString *labelJump;
    
    
}MAPSCRIPT2;

typedef struct _MAPSCRIPT3{
    //出現スクリプト
    
    struct _MAPSCRIPT3 *next;
    
    int x;
    int y;
    bool flag;
    
    int type;
    int team;
    
    UNITCHIP U;
    int unitNum;
    
    int loadInt;
}MAPSCRIPT3;

typedef struct _MAPSCRIPT5{
    //消滅スクリプト
    
    struct _MAPSCRIPT5 *next;
    
    int x;
    int y;
    
    int type;
    int team;
    
    UNITCHIP U;
    int unitNum;
    
    int saveInt;
}MAPSCRIPT5;

typedef struct _PLACEMENT{
    
    struct _PLACEMENT *next;
    
    int type;
    int x;
    int y;
    int z;
    int x2;
    int y2;
    
}PLACEMENT;

typedef struct _UNIT2{
    
    struct _UNIT2 *next;
    UNITCHIP C;
    
    int team;
    int x;
    int y;
    
}UNIT2;

typedef struct _BUILD2{
    
    struct _BUILD2 *next;
    struct _BUILDCHIP *C;
    
    int team;
    int x;
    int y;
    
}BUILD2;

typedef struct _MAPSCRIPT4{
    
    bool lagFixFlag;
    
    NSString *COMPrabel;
    NSString *FAILrabel;
    
    bool suicchiFlag;
    int suicchiCnt;
    int *suicchi;
    bool suicchiONOFF;
    
    bool hensuFlag;
    int hensu1;
    bool teisuFlag;
    int teisuValue;
    bool hensu2flag;
    int hensu2;
    int hensuType;
    
    bool timerFlag;
    int timerMin;
    int timerSec;
    int timerType;
    
    bool unitNumFlag;
    int team;
    int unitNum;
    int unitType;
    bool unitTypeFlag;
    
    int subjCnt;
    UNIT2 *subj;
    
    bool placeFlag;
    int waypCnt;
    PLACEMENT *wayp;
    
    bool unitCMDflag;
    int unitCMD;
    
    bool objeFlag;
    int objeCnt;
    UNIT2 *obje;
    int objeRange;
    bool buildFlag;
    int buildCnt;
    BUILD2 *build;
    
    
}MAPSCRIPT4;

typedef struct _MAPSCRIPT6{
    
    int team;
    
    bool RCsupply;
    bool RCfood;
    bool RCmoney;
    
    bool RCsupplyAdd;
    bool RCfoodAdd;
    bool RCmoneyAdd;
    
    int RCsupplyValue;
    int RCfoodValue;
    int RCmoneyValue;
    
    int RCsupplySelect;
    int RCfoodSelect;
    int RCmoneySelect;
    
    bool RCsupplyS;
    bool RCfoodS;
    bool RCmoneyS;
}MAPSCRIPT6;

typedef struct _MAPSCRIPT7A{
    
    struct _MAPSCRIPT7A *next;
    
    int x;
    int y;
    int team;
    
    int unitNum;
    UNITCHIP U;
    
}MAPSCRIPT7A;

typedef struct _MAPSCRIPT7B{
    
    struct _MAPSCRIPT7B *next;
    
    int x;
    int y;
    int team;
    
    int unitNum;
    UNITCHIP U;
    
    int saveInt;
    
}MAPSCRIPT7B;

typedef struct _MAPSCRIPT7{
    
    int type;
    bool maxFlag;
    bool percentFlag;
    bool extendFlag;
    int fluctuate;
    int valueType;
    NSString *value;
    int rdm;
    
    bool teamFlag;
    int team;
    bool unitFlag;
    struct _MAPSCRIPT7A *A;
    bool valueFlag;
    struct _MAPSCRIPT7B *B;
    
    int S7Acnt;
    int S7Bcnt;
    
}MAPSCRIPT7;

typedef struct _MAPSCRIPT0{
    bool endFlag;
    bool succeessfulFlag;
    int indent;
    struct _MAPSCRIPT0 *next;
    
    int type;
    struct _MAPSCRIPT1 S1;
    struct _MAPSCRIPT2 *S2;
    struct _MAPSCRIPT3 *S3;
    struct _MAPSCRIPT4 S4;
    struct _MAPSCRIPT5 *S5;
    struct _MAPSCRIPT6 S6;
    struct _MAPSCRIPT7 S7;
    
    int S2cnt;
    int S3cnt;
    int S5cnt;
    
    int val;
    int valCnt;
    
    int timerMin;
    int timerSec;
    int timerEntire;
    bool timerFlag;
    bool timerVisible;
    bool timerRun;
    bool timerMode;
    double wait;
    
    bool titleBack;
    
    NSString *label;
    NSString *labelJump;
    NSString *memo;
    
    int switch1cnt;
    int switch2cnt;
    int *switch1;
    int *switch2;
    
    BGMUSIC BGM;
    SEFFECT SE;
    
    STAGECLEAR sc;
    GAMEOVER gaov;
    
}MAPSCRIPT0;

typedef struct _MAPSCRIPTD{
    bool endFlag;
    int SCRPTcnt;
    NSMutableArray *SCRPT;
    struct _MAPSCRIPTD *next;
    
    int Pcnt;
    struct _MAPSCRIPT0 *P;
    int index;
    int x;
    int y;
    int type;
    double ET1;
    double ET2;
    double ET3;
    double ET4;
    int ETtype;
    bool onlyInitialDeley;
    bool initialDeleyedFlag;
    
    bool switch1f;
    bool switch2f;
    int switch1cnt;
    int switch2cnt;
    int *switch1;
    int *switch2;
    
    
}MAPSCRIPTD;

typedef struct _MAPSCRIPT{
    ENDGAMECONDITION EGClight;
    ENDGAMECONDITION EGCdark;
    int Dcnt;
    struct _MAPSCRIPTD *D;
    int SCRPTnameCnt;
    NSMutableArray *SCRPTname;
    
    
    int playerSet1;
    int playerSet2;
    bool battleSetMode;
    bool employAllowedFlag;
    bool buildAllowedFlag;
    bool summonAllowedFlag;
    
    bool scenarioSetMode;
    int scenarioNumbCrnt;
    int scenarioNumbNext;
    int guildListRegist[4096];
    int guildListRegistNum11;
    int guildListRegistNum12;
    int guildListRegist2[4096];
    int guildListRegistNum21;
    int guildListRegistNum22;

    
}MAPSCRIPT;

typedef struct _MAPFILE{
    
    NSString *fileName;
    
    MAPSCRIPT MS;
    
}MAPFILE;

MAPFILE MF[512];
ENDGAMECONDITION EGC[2];
MAPSCRIPTD *MSDTOPP;//一番もとの先頭
MAPSCRIPTD *MSDTOP;//一番先頭
MAPSCRIPTD *msdtop;//スクリプト上の先頭

MAPSCRIPT0 *MS0T;
MAPSCRIPT3 *MS3T;
MAPSCRIPT5 *MS5T;

MAPSCRIPT7A *MS7Atop;
MAPSCRIPT7B *MS7Btop;

BGMUSIC BGM[999];
SEFFECT SE[9999];

#define dUMAX 9999
#define dBMAX 9999
typedef struct _SAVEDATADAT{
    
    NSString *name;
    
    int imgAdressCnt;
    int imgAdressFix;
    NSImage *img;
    
    int MFselectedRow;
    int storyNumb;
    int scenarioNumb;
    
    NSString *mapfileName;
    NSString *levelName;
    NSString *scenarioName;
    
    int chipHeight;
    int chipWidth;
    
    int posX;
    int posY;
    
    int eSlctX;
    int eSlctY;
    
    int registerNum;
    int registerNumB;
    
    int esSceneProc;
    
    bool endGameCondition;
    bool initMapFlag;
    bool initStatusFlag;
    bool TeamCountFlag;
    bool battleBegin;
    bool startES;
    
    bool cpuAImodeflag;
    bool cpuModeMOVEflag;
    bool cpuModeATTACKflag;
    bool cpuTurnEndFlag;
    bool waitSwtichFlag;
    bool battleReadyUpFlag;
    bool setBattleModeFlag;
    
    bool wtRdy;
    bool wtRdy2;
    bool wtRdy3;
    
    bool wtMovedFlag;
    bool wtAttackedFlag;
    bool unitMoveEndFlag;
    bool battleSetUp;
    bool pushStanbyFlag;
    bool battleEndFlag;
    int wtUnitNum;
    bool messageDialog;
    
    /*//容量を取るため省略か
    int chipNum[1002][1002];
    int buildNum[1002][1002];
    int unitNum[1002][1002];
    int loadNum[1002][1002];
    int buildTeam[1002][1002];
    int unitTeam[1002][1002];
    */
    
    //あったものを読み込むというよりは一部のデータをもとに再現するのにおよそ等しい
    struct _UNITD dU[dUMAX];
    struct _BUILDD dB[dBMAX];
    
    struct _PLAYER P[3];
    
    bool Suicchi[9999];
    int HensuuNum;
    NSString *Hensuu[65000];
    NSString *HensuuName[65000];
    
    struct _MAPSCRIPT MS;
}SAVEDATADAT;

int datRow;
SAVEDATADAT sdd;
SAVEDATADAT sdd2[SAVEDATADATMAX];

int routeCnt;
bool datExistFlag;
NSImage *changedImg;
bool saveFlag;

bool saveDataDatFlag;
bool textInstantBugFixFlag;

struct _MAPSCRIPT0 *MSDP0top;
struct _MAPSCRIPT0 *MSDPtop;

int slctedBtnNum;
int slctBtnNum;
NSPoint slctPoint;

bool appearanceSAIKIflag;
bool waitx10flag;
bool waitSwtichFlag;
bool waitAllOverFlag;
double waitinTime;
NSSound *BGMsub;
NSSound *SEsub;

bool attackingWait;

bool damnitFixFlag;
bool crapBugFixFlag;

bool eventEndFlag;
int displayBattleCheckPanelFlag;

bool gameOverFlag;
bool gameOverFlag2;
struct _GAMEOVER gaov;

bool stageClearFlag;
bool stageClearFlag2;


bool backTitleFlag;
bool backTitleFlag2;

int cntTimerMin;
int cntTimerSec;

bool coolTime;

int waypR[1002][1002];
int objeR[1002][1002];
int apprR[1002][1002];
UNITPOINT *postUnitPoint;
UNITPOINT *postUnitPointTop;
bool unitPointMakeSureFlag;
bool unitPointMakeSureFlag2;

UNITPOINT *UP;
UNITPOINT *UPT;

bool pussyLoopFlag;
bool pussyCumsOnlyOnceFlag;

int wtflag;

bool atkExtentFlag;
int DUNnum;
bool extentBattleFlag2;
bool extentMPcostFlag;

int *GuildChosen1;
int *GuildChosen2;
int GCnum1;
int GCnum2;

int *GuildDisp1;
int *GuildDisp2;

int *saveGuildList;
int guildc;
bool guildRE1;
bool guildRE2;
int Gnum1;
int Gnum2;

int mapChipDataLoadProc;

int LFOLrow;

char *datFilePath;
bool datFileLoadCompFromTitle;
bool datFileLoadCompFromField;

NSSound *titleBGM;
AVPlayer *openingAVP;
bool openingAVPVisHidden;
bool openingAVPVisActive;
bool openingAVPisDeactive;

bool battleIsProcFlag;

int STErow;

@interface FieldScene : NSObject
{
    NSTimer *time;
    
    IBOutlet AVPlayerView *openingAVPV;
    
    
    IBOutlet NSTextField *dmgFixTF;
    IBOutlet NSTextField *recoveryTF;
    
    IBOutlet NSTextField *btHITtf1;
    IBOutlet NSTextField *btHITtf2;
    IBOutlet NSTextField *btDMGtf1;
    IBOutlet NSTextField *btDMGtf2;
    
    IBOutlet NSTextField *battleReadyUpPN1;
    IBOutlet NSTextField *battleReadyUpPN2;
    IBOutlet NSTextField *battleReadyUpRule;
    IBOutlet NSButtonCell *battleReadyUpMAN1A;
    IBOutlet NSButtonCell *battleReadyUpMAN1B;
    IBOutlet NSButtonCell *battleReadyUpMAN2A;
    IBOutlet NSButtonCell *battleReadyUpMAN2B;
    IBOutlet NSTextField *battleReadyUpSupply1;
    IBOutlet NSTextField *battleReadyUpFood1;
    IBOutlet NSTextField *battleReadyUpMoney1;
    IBOutlet NSTextField *battleReadyUpSupply2;
    IBOutlet NSTextField *battleReadyUpFood2;
    IBOutlet NSTextField *battleReadyUpMoney2;
    IBOutlet NSTextField *battleReadyUpLeader1;
    IBOutlet NSTextField *battleReadyUpLeader2;
    IBOutlet NSImageView *battleReadyUpIV1;
    IBOutlet NSImageView *battleReadyUpIV2;
    IBOutlet NSWindow *bsWindow;
    
    IBOutlet NSImageView *selectMesh;
    IBOutlet NSTextField *selectMeshText;
    IBOutlet NSTextField *selectMeshValue;
    IBOutlet NSImageView *selectChara;
    
    IBOutlet NSWindow *mapWindow;
    
    IBOutlet NSPanel *menuPanel;
    IBOutlet NSButton *TFmove;
    IBOutlet NSButton *TFattack;
    IBOutlet NSButton *TFstandby;
    IBOutlet NSButton *TFcreate;
    IBOutlet NSButton *TFstatus;
    IBOutlet NSButton *TFcancel;
    
    IBOutlet NSPanel *menuPanel2;
    IBOutlet NSButton *TFstatus2;
    IBOutlet NSButton *TFcancel2;
    
    
    NSMutableArray *CAttackListMA;
    IBOutlet NSArrayController *CAttackListAC;
    IBOutlet NSTableView *CAttackListTV;
    
    IBOutlet NSPanel *atkPanel;
    NSPoint windowPoint;
    
    NSMutableArray *BCreateListMA;
    IBOutlet NSArrayController *BCreateListAC;
    IBOutlet NSTableView *BCreateListTV;
    
    IBOutlet NSPanel *createPanel;
    
    NSMutableArray *CSummonListMA;
    IBOutlet NSArrayController *CSummonListAC;
    IBOutlet NSTableView *CSummonListTV;
    
    IBOutlet NSPanel *summonPanel;
    
    IBOutlet NSTextField *bullet;
    IBOutlet NSTextField *costP;
    IBOutlet NSTextField *costV;
    IBOutlet NSTextField *region;
    IBOutlet NSTextField *crytical;
    IBOutlet NSTextField *atkProperty;
    
    IBOutlet NSTextField *HPbarTF;
    IBOutlet NSLevelIndicator *HPbarLI;
    IBOutlet NSTextField *MPbarTF;
    
    
    IBOutlet NSWindow *battleWindow;
    IBOutlet NSImageView *bplayer1;
    IBOutlet NSImageView *bplayer2;
    IBOutlet NSTextField *nplayer1;
    IBOutlet NSTextField *nplayer2;
    IBOutlet NSTextField *tplayer1;
    IBOutlet NSTextField *tplayer2;
    IBOutlet NSLevelIndicator *lplayer1;
    IBOutlet NSLevelIndicator *lplayer2;
    IBOutlet NSTextField *mplayer1;
    IBOutlet NSTextField *mplayer2;
    IBOutlet NSImageView *iplayer1;
    IBOutlet NSImageView *iplayer2;
    IBOutlet NSTextField *rplayer1;
    IBOutlet NSTextField *rplayer2;
    IBOutlet NSTextField *hplayer1;
    IBOutlet NSTextField *hplayer2;
    IBOutlet NSTextField *battleDialog;
    IBOutlet NSButton *battleCancelBtn;
    IBOutlet NSButton *battleAttackBtn1;
    IBOutlet NSButton *battleAttackBtn2;
    IBOutlet NSButton *battleGuardBtn1;
    IBOutlet NSButton *battleGuardBtn2;
    IBOutlet NSButton *battleDodgeBtn1;
    IBOutlet NSButton *battleDodgeBtn2;
    IBOutlet NSButton *battleStartBtn;
    
    IBOutlet NSTextField *tfAttack;
    IBOutlet NSTextField *tfDefence;
    IBOutlet NSTextField *tfCalc;
    IBOutlet NSTextField *tfHit;
    IBOutlet NSTextField *tfDodge;
    IBOutlet NSTextField *tfMove;
    IBOutlet NSTextField *tfWait;
    
    IBOutlet NSTextField *tfName;
    IBOutlet NSTextField *tfArmy;
    IBOutlet NSTextField *tfResource;
    IBOutlet NSTextField *tfFood;
    IBOutlet NSTextField *tfMoney;
    
    IBOutlet NSPanel *battlePanel;
    IBOutlet NSTextField *combatNAME1;
    IBOutlet NSTextField *combatNAME2;
    IBOutlet NSTextField *combatHP1;
    IBOutlet NSTextField *combatHP2;
    IBOutlet NSTextField *combatMP1;
    IBOutlet NSTextField *combatMP2;
    IBOutlet NSLevelIndicator *combatLHP1;
    IBOutlet NSLevelIndicator *combatLHP2;
    IBOutlet NSLevelIndicator *combatLMP1;
    IBOutlet NSLevelIndicator *combatLMP2;
    IBOutlet NSTextField *combatHIT1;
    IBOutlet NSTextField *combatHIT2;
    IBOutlet NSTextField *combatVIG1;
    IBOutlet NSTextField *combatVIG2;
    IBOutlet NSTextField *combatAP1;
    IBOutlet NSTextField *combatAP2;
    IBOutlet NSTextField *combatATK1;
    IBOutlet NSTextField *combatATK2;
    
    IBOutlet NSPanel *researchPanel;
    IBOutlet NSTextField *researchATK;
    IBOutlet NSTextField *researchDEF;
    IBOutlet NSTextField *researchCAP;
    IBOutlet NSTextField *researchACU;
    IBOutlet NSTextField *researchEVA;
    IBOutlet NSTextField *researchMOV;
    IBOutlet NSImageView *researchIMG;
    
    NSMutableArray *CResearchListMA;
    IBOutlet NSArrayController *CResearchListAC;
    IBOutlet NSTableView *CResearchListTV;
    
    ATTACK *U2A;
    double dmg;
    double hit;
    double hitFix;
    double mapDmgFix;
    double costMP;
    double costVIG;
    bool healFlag;
    double graze;
    bool grazeFlag;
    
    IBOutlet NSWindow *titleWindow;
    IBOutlet NSWindow *esWindow;
    IBOutlet NSWindow *fsWindow;
    IBOutlet NSPanel *endGamePanel;
    IBOutlet NSTextField *endGameText;
    
    IBOutlet NSPanel *commandPanel;
    IBOutlet NSButton *moveBtn;
    IBOutlet NSButton *attackBtn;
    IBOutlet NSButton *stanbyBtn;
    IBOutlet NSButton *createBtn;
    IBOutlet NSButton *summonBtn;
    IBOutlet NSButton *statusBtn;
    IBOutlet NSButton *cancelBtn;
    
    bool buildSkillFlag;
    bool summonSkillFlag;
    
    IBOutlet NSImageView *IVimage;
    IBOutlet NSTextField *TFmessage;
    IBOutlet NSTextField *TFname;
    IBOutlet NSBox *BXmessage;
    IBOutlet NSBox *BXname;

    IBOutlet NSPanel *fsEffectPanel;
    IBOutlet AVPlayerView *AVPV;
    AVPlayer *AVpreview;
    
    
    IBOutlet NSWindow *selectionWindow;
    IBOutlet NSButton *slctBtn1;
    IBOutlet NSButton *slctBtn2;
    IBOutlet NSButton *slctBtn3;
    IBOutlet NSButton *slctBtn4;
    IBOutlet NSButton *slctBtn5;
    IBOutlet NSButton *slctBtn6;
    IBOutlet NSButton *slctBtn7;
    IBOutlet NSButton *slctBtn8;
    IBOutlet NSButton *slctBtn9;
    
    IBOutlet NSWindow *GameOverWindow;
    IBOutlet NSImageView *GameOverIV;
    
    IBOutlet NSWindow *STwindow;
    
    IBOutlet NSImageView *STIV;
    IBOutlet NSTextField *STnameTF;
    IBOutlet NSTextField *STclassTF;
    IBOutlet NSTextField *SThpTF;
    IBOutlet NSTextField *STmpTF;
    IBOutlet NSTextField *STatkTF;
    IBOutlet NSTextField *STdefTF;
    IBOutlet NSTextField *STcapTF;
    IBOutlet NSTextField *STacuTF;
    IBOutlet NSTextField *STevaTF;
    IBOutlet NSTextField *STstrTF;
    IBOutlet NSTextField *STvitTF;
    IBOutlet NSTextField *STagiTF;
    IBOutlet NSTextField *STdexTF;
    IBOutlet NSTextField *STmenTF;
    IBOutlet NSTextField *STintTF;
    IBOutlet NSTextField *STmelTF;
    IBOutlet NSTextField *STmisTF;
    IBOutlet NSTextField *SThitTF;
    IBOutlet NSTextField *STdodTF;
    IBOutlet NSTextField *STreaTF;
    IBOutlet NSTextField *STskiTF;
    IBOutlet NSTextField *STvigTF;
    
    NSMutableArray *STjoinListMA;
    IBOutlet NSArrayController *STjoinListAC;
    IBOutlet NSTableView *STjoinListTV;
    
    NSMutableArray *STequipListMA;
    IBOutlet NSArrayController *STequipListAC;
    IBOutlet NSTableView *STequipListTV;
    
    NSMutableArray *STskillListMA;
    IBOutlet NSArrayController *STskillListAC;
    IBOutlet NSTableView *STskillListTV;
    
    IBOutlet NSPanel *FSMenu;
    
    IBOutlet NSWindow *saveFileDialog;
    
    IBOutlet NSPanel *saveFileInputPanel;
    IBOutlet NSTextField *saveFileInputTF;
    NSMutableArray *saveFileInputListMA;
    IBOutlet NSArrayController *saveFileInputListAC;
    IBOutlet NSTableView *saveFileInputListTV;
    
    IBOutlet NSPanel *loadFileOutputPanel;
    IBOutlet NSTextField *loadFileOutputTF;
    NSMutableArray *loadFileOutputListMA;
    IBOutlet NSArrayController *loadFileOutputListAC;
    IBOutlet NSTableView *loadFileOutputListTV;
    
    
    IBOutlet NSPanel *saveGamePanel;
    IBOutlet NSTextField *saveGameTF;
    IBOutlet NSImageView *saveGameIV;
    IBOutlet NSTextField *saveGameLB;
    NSMutableArray *saveGameListMA;
    IBOutlet NSArrayController *saveGameListAC;
    IBOutlet NSTableView *saveGameListTV;
    
}
-(void)loadStruct;
-(void)openingAVPVfunc;

-(IBAction)saveGameSubmit:(id)sender;
-(IBAction)saveGameCancel:(id)sender;

-(struct MAPSCRIPT0*)setMessage:(struct MAPSCRIPT0*)MS0;

-(IBAction)loadFileOutputSubmit:(id)sender;
-(IBAction)loadFileOutputCancel:(id)sender;

-(IBAction)saveFileInputSubmit:(id)sender;
-(IBAction)saveFileInputCancel:(id)sender;

-(IBAction)saveFileDialogSubmit:(id)sender;
-(IBAction)saveFileDialogCancel:(id)sender;

-(IBAction)STsubmit:(id)sender;

-(IBAction)battleReadyUpStartBtn:(id)sender;
-(IBAction)battleReadyUpState1:(id)sender;
-(IBAction)battleReadyUpState2:(id)sender;

-(IBAction)pushMove:(id)sender;
-(IBAction)pushAttack:(id)sender;
-(IBAction)pushStandby:(id)sender;
-(IBAction)pushCreate:(id)sender;
-(IBAction)pushSummon:(id)sender;
-(IBAction)pushStatus:(id)sender;
-(IBAction)pushCancel:(id)sender;

-(IBAction)battleStart:(id)sender;
-(IBAction)battleSet1:(id)sender;
-(IBAction)battleDef1:(id)sender;
-(IBAction)battleDod1:(id)sender;
-(IBAction)battleSet2:(id)sender;
-(IBAction)battleDef2:(id)sender;
-(IBAction)battleDod2:(id)sender;
-(IBAction)battleCancel:(id)sender;

-(IBAction)pushCancelCAL:(id)sender;
-(IBAction)pushCancelBCL:(id)sender;
-(IBAction)pushCancelCSL:(id)sender;

-(IBAction)researchCancel:(id)sender;

-(IBAction)selectionBtn1:(id)sender;
-(IBAction)selectionBtn2:(id)sender;
-(IBAction)selectionBtn3:(id)sender;
-(IBAction)selectionBtn4:(id)sender;
-(IBAction)selectionBtn5:(id)sender;
-(IBAction)selectionBtn6:(id)sender;
-(IBAction)selectionBtn7:(id)sender;
-(IBAction)selectionBtn8:(id)sender;
-(IBAction)selectionBtn9:(id)sender;

-(IBAction)gameOverSubmit:(id)sender;












-(IBAction)FSVsave:(id)sender;
-(IBAction)FSVtitle:(id)sender;
-(IBAction)FSVcancel:(id)sender;


-(int)chooseGuildList:(int*)value gcnum:(int)gcnum;
-(void)addBuildStatus;
-(void)displaySideMenu;
-(void)displaySaveFileDialog;
-(void)initLoadFileOutputList;
-(void)initFileOutPutListSet;

-(void)loadGameDataDat;

-(void)loadOptionMenu;
-(void)saveOptionMenu;
-(void)loadStandImages;
-(void)saveStandImages;

@end

FieldScene *fieldScene;
bool fieldSceneSelfFlag;



@interface FieldSceneEF : NSView
{
    NSTimer *time;
}

@end










