//
//  ScenarioEditor.h
//  Awars III
//
//  Created by Killery on 2013/01/28.
//  Copyright (c) 2013年 Killery. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "StringText.h"

typedef struct _STAND{
    int cntBASE;
    struct _STAND *next;
    struct _BASE *B;
    
    NSString *name;
    
    int index;
    int registerNum;
}STAND;

typedef struct _BASE{
    int cntLAYER;
    struct _BASE *next;
    int index;
    struct _LAYER *L;
    
    NSString *name;
    NSImage *img;
    int imgAdCnt;
    int imgAdFix;
    
    int x;
    int y;
    int z;
}BASE;

typedef struct _LAYER{
    struct _LAYER *next;
    int index;

    NSString *name;
    NSImage *img;
    int imgAdCnt;
    int imgAdFix;
    
    bool visible;
    
    bool visibleInstant;
    
    int x;
    int y;
    int z;
}LAYER;

typedef struct _STANDARRAY{
    int cntSTAND;
    struct _STAND *S;
    
}STANDARRAY;

typedef struct _TEXT{
    
    NSString *fileName;
    NSMutableArray *SIarray;
    struct _STRING *S;
    
}TEXT;

enum{
    TEXTMAX = 255
};

TEXT TX[TEXTMAX];

STANDARRAY stand;

STAND *I;
STAND *Itop;
BASE *IBtop;
LAYER *IBLtop;

int Irow;
int IBrow;
int IBLrow;

int LLrow;

BASE *b;
int Inumb;

int Standcount;

NSInteger SEMA1row;
NSInteger SEMA2row;
NSInteger SEMA3row;

NSInteger SEMArow;

bool standEditorFlag;
bool standChoiceFlag;

int loopbugomfg;

int imgSGx;
int imgSGy;

NSInteger st;
NSInteger sl;
struct _STRING *STRtop[TEXTMAX];

struct _STRING *STRSI;
struct _STRING *STRSItop;

int siCnt;
int siPostNum;

NSString *STANDADDSTRING;
NSSound *testSnd;
NSSound *testSndEff;

bool baseClickedFlag;
bool layerClickedFlag;

@interface ScenarioEditor : NSObject
{
    IBOutlet NSImageView *testIV;

    
    IBOutlet NSWindow *SEstandWindow;
    IBOutlet NSImageView *SEIV;
    IBOutlet NSTextField *SEstandTF;
    
    IBOutlet NSTextField *SEstandTF0;
    
    IBOutlet NSTextField *SEstandTFx;
    IBOutlet NSTextField *SEstandTFy;
    
    NSMutableArray *textListMA;
    IBOutlet NSArrayController *textListAC;
    IBOutlet NSTableView *textListTV;
    
    
    IBOutlet NSWindow *SEstandViewTestWindow;
    
    NSTimer *time;
    
    IBOutlet NSWindow *scenarioEditorWindow;
    IBOutlet NSWindow *titleWindow;
    
    NSMutableArray *SEMA;
    IBOutlet NSArrayController *SEAC;
    IBOutlet NSTableView *SETV;
    
    NSMutableArray *lineListMA;
    IBOutlet NSArrayController *lineListAC;
    IBOutlet NSTableView *lineListTV;
    
    NSInteger textNumb;
    NSInteger listNumb;
    
    IBOutlet NSTextField *Dname;
    IBOutlet NSTextField *Dstring;
    
    IBOutlet NSTextField *dialogName;
    IBOutlet NSTextField *dialogString;
    IBOutlet NSImageView *dialogImage;

    bool OMFGflag;
    
    NSMutableArray *standListMA;
    IBOutlet NSArrayController *standListAC;
    IBOutlet NSTableView *standListTV;
    
    NSMutableArray *baseListMA;
    IBOutlet NSArrayController *baseListAC;
    IBOutlet NSTableView *baseListTV;
    NSDictionary *baseListDC;
    
    NSMutableArray *layerListMA;
    IBOutlet NSArrayController *layerListAC;
    IBOutlet NSTableView *layerListTV;
    
    
    IBOutlet NSPanel *standPanel;
    IBOutlet NSPanel *standEditorPanel;
    
    IBOutlet NSTextField *TFposX;
    IBOutlet NSTextField *TFposY;
    
    IBOutlet NSImageView *NSIV;
    IBOutlet NSImageView *NSIV2;
    
    IBOutlet NSWindow *detailWindow;
    
    IBOutlet NSImageView *IVface;
    IBOutlet NSImageView *IVwall;
    IBOutlet NSImageView *IVstand;
    
    IBOutlet NSTextField *TFface;
    IBOutlet NSTextField *TFwall;
    IBOutlet NSTextField *TFstand;
    IBOutlet NSTextField *TFbgm;
    IBOutlet NSTextField *TFse;
    
    IBOutlet NSButton *FIbtn;
    IBOutlet NSButton *FObtn;
    
    
    
    
    NSMutableArray *MA1;
    IBOutlet NSArrayController *AC1;
    IBOutlet NSTableView *TV1;
    IBOutlet NSImageView *IV1;
    
    NSMutableArray *MA2;
    IBOutlet NSArrayController *AC2;
    IBOutlet NSTableView *TV2;
    IBOutlet NSImageView *IV2;
    
    
    
    NSMutableArray *SEMA1;
    IBOutlet NSArrayController *SEAC1;
    IBOutlet NSTableView *SETV1;

    NSMutableArray *SEMA2;
    IBOutlet NSArrayController *SEAC2;
    IBOutlet NSTableView *SETV2;
    
    NSMutableArray *SEMA3;
    IBOutlet NSArrayController *SEAC3;
    IBOutlet NSTableView *SETV3;
    
    
    
    
    
    IBOutlet NSImageView *SESTIV;
}

-(IBAction)bgmRunBtn:(id)sender;
-(IBAction)bgmStopBtn:(id)sender;
-(IBAction)seRunBtn:(id)sender;

-(IBAction)titleBtn:(id)sender;
-(IBAction)detailBtn:(id)sender;
-(IBAction)standBtn:(id)sender;
-(IBAction)saveLineData:(id)sender;

-(IBAction)insertLineStand:(id)sender;
-(IBAction)removeLineStand:(id)sender;
-(IBAction)backStand:(id)sender;

-(IBAction)insertLineBase:(id)sender;
-(IBAction)removeLineBase:(id)sender;
-(IBAction)insertLineLayer:(id)sender;
-(IBAction)removeLineLayer:(id)sender;
-(IBAction)submitStand:(id)sender;

-(IBAction)insertLine:(id)sender;
-(IBAction)removeLine:(id)sender;

-(IBAction)stringData:(id)sender;

-(IBAction)detailClose:(id)sender;

-(IBAction)addTextList:(id)sender;
-(IBAction)removeTextList:(id)sender;



-(IBAction)insert1:(id)sender;
-(IBAction)insert2:(id)sender;

-(IBAction)remove1:(id)sender;
-(IBAction)remove2:(id)sender;

-(IBAction)saveBtn:(id)sender;

-(IBAction)SEstand:(id)sender;
-(IBAction)SEstandSubmit:(id)sender;

-(IBAction)SEstandSEclear:(id)sender;
-(IBAction)SEstandSEadd:(id)sender;
-(IBAction)SEstandSEremove:(id)sender;

-(IBAction)SEstandXsubmit:(id)sender;
-(IBAction)SEstandYsubmit:(id)sender;

-(void)testSEtest;

-(void)setTFpos;
-(IBAction)TFposXsubmit:(id)sender;
-(IBAction)TFposYsubmit:(id)sender;

@end

NSImage *SEstandImg;

@interface SEstandView: NSView
{
    NSTimer *time;
}
@end

@interface SEstandViewTest: NSView
{
    NSTimer *time;
}
@end


NSImage *SEstandImgST;
int STSNUM;

int txNumb;
int txiNumb;
bool TXimgCaptured;
bool TXimgIsNull;

TEXT TXCPY[TEXTMAX];
bool TXCPYcpy;
bool allowTXcpy;
@interface SEstandViewST: NSView
{
    NSTimer *time;
    int TXCPYSnum;
    int TXCPYSInum;
}
@end

ScenarioEditor *testScenarioEditor;



