//
//  Title.m
//  Awars III
//
//  Created by Killery on 2012/12/06.
//  Copyright (c) 2012年 Killery. All rights reserved.
//0120-001-144

#import "Title.h"
#import "ScenarioEditor.h"

@implementation Title

-(void)awakeFromNib{
    [IVTitle setImageScaling:NSScaleToFit];
}

-(id)init
{
    [super init];
    if (self) {
        timer = [NSTimer
                 scheduledTimerWithTimeInterval:0.1
                 target:self selector:@selector(EventLoopTitle:)
                 userInfo:nil repeats:YES
                 ];
    }
    
    title = self;
    
    return self;
}

-(void)loadFromOM:(bool)movON{
    [nameTitleTF setStringValue:wtfom.nameTitle];
    [nameVerionTF setStringValue:wtfom.nameVersion];
    
    [IVTitle setImage:wtfom.imgTitle];
    
    if(wtfom.allowMapEditor)
        [mapEditorBtn setEnabled:YES];
    else
        [mapEditorBtn setEnabled:NO];
    if(wtfom.allowScenarioEditor)
        [scenarioEditorBtn setEnabled:YES];
    else
        [scenarioEditorBtn setEnabled:NO];
    openingAVPVisActive = true;
    
    if(movON)
    if(openingAVP){
        if(!wtfom.onlyOnceOpening){
            openingAVPVisHidden = false;
            [fieldScene openingAVPVfunc];
            [openingAVP play];
            wtfom.newOpeningIsShown = true;
        }else if(wtfom.onlyOnceOpening && !wtfom.newOpeningIsShown){
            openingAVPVisHidden = false;
            [fieldScene openingAVPVfunc];
            [openingAVP play];
            wtfom.newOpeningIsShown = true;
        }else{
            openingAVPVisHidden = true;
            [fieldScene openingAVPVfunc];
        }
    }
}

-(void)EventLoopTitle:(NSTimer *)timer{

    static bool StandImageLoadOK = false;
    
    if(allowTXcpy && !StandImageLoadOK){
        [TitleWindow makeKeyAndOrderFront:nil];
        
        StandImageLoadOK = true;
    }
}

-(IBAction)Start:(id)sender{
    startClickedFlag = true;
    [scenarioList initScenarioList];
    
    NSPoint SLPpoint;
    
    SLPpoint.x = [TitleWindow frame].origin.x + 100;
    SLPpoint.y = [TitleWindow frame].origin.y + 100;
    [StartWindow setFrameOrigin:SLPpoint];
    
    [StartWindow makeKeyAndOrderFront:nil];
}

-(IBAction)Continue:(id)sender{
    [saveDataList initSaveList];
    [ContinueWindow makeKeyAndOrderFront:nil];
}
-(IBAction)Gallery:(id)sender{
    galleryClickedFlag = true;
    [GalleryWindow makeKeyAndOrderFront:nil];
    windowPoint.x = [TitleWindow frame].origin.x;
    windowPoint.y = [TitleWindow frame].origin.y;
    [GalleryWindow setFrameOrigin:windowPoint];
    [TitleWindow close];
    
}
-(IBAction)Option:(id)sender{
    if(titleBGM) [titleBGM stop];
    [fieldScene loadOptionMenu];
    [optionMenu loadOM];
    windowPoint.x = [TitleWindow frame].origin.x;
    windowPoint.y = [TitleWindow frame].origin.y;
    [OptionWindow setFrameOrigin:windowPoint];
    [OptionWindow makeKeyAndOrderFront:nil];
}
-(IBAction)MapEditor:(id)sender{
    if(titleBGM) [titleBGM stop];
    [MapEditorWindow makeKeyAndOrderFront:nil];
    windowPoint.x = [TitleWindow frame].origin.x;
    windowPoint.y = [TitleWindow frame].origin.y;
    [MapEditorWindow setFrameOrigin:windowPoint];
    [mapEditor initEventGuildList];
    [TitleWindow close];
}
-(IBAction)ScenarioEditor:(id)sender{
    if(titleBGM) [titleBGM stop];
    [ScenarioEditorWindow makeKeyAndOrderFront:nil];
}
-(IBAction)Quit:(id)sender{
    
    [fieldScene saveOptionMenu];
    [NSApp terminate:self];
}

@end




@implementation TitleView

-(void)scrollWheel:(NSEvent *)theEvent{
    
    theEvent = NULL;
    
}

- (void)mouseUp:(NSEvent *)event
{
    NSInteger clickCount = [event clickCount];
    if (2 == clickCount) openingAVPisDeactive = true;
}



@end
